



// Modul do szybkiego wypelniania scianek jednym kolorem w grafice 13h
//		by Pawelek Biernacki

// modyfikacja do badania punktowej kolizji

#include <dos.h>


int T[400]; // tablica do wypelniania
unsigned T_seg=FP_SEG(T),T_off=FP_OFF(T);
unsigned ekran_seg=0xa000,ekran_off=0;
int MAXY=199;

unsigned kolizja=0,kolizja_x=0,kolizja_y=0;

unsigned char miny=50,maxy=150;

unsigned char kolor=4;



extern "C" void fill(void),przygotuj_fill(void);




void grafika(unsigned char tryb)
{
 asm {
 push ax
 mov ah,0
 mov al,tryb
 int 0x10
 pop ax
 }
}


int prec=6;
int xym,xyw,ym,yw,delta_x,x_dokl;

// przejscie po brzegu wypelnianego wielokata i przygotowanie tablicy T
void linia(int x1,int y1,int x2,int y2)
{

	if (y1<y2)
		{ ym=y1; yw=y2; xym=x1; xyw=x2; } else
		{ ym=y2; yw=y1; xym=x2; xyw=x1; }


	if (!(((ym<0) && (yw<0)) || ((ym>MAXY) && (yw>MAXY))))
	{

	if (ym<yw)
	{

	if (ym<0)
		{
		xym=xym-(xyw-xym)*ym/(yw-ym);
		ym=0;
		}

	if (ym<yw)
	{

	if (yw>MAXY)
		{
		xyw=xyw+(xym-xyw)*(MAXY-yw)/(ym-yw);
		yw=MAXY;
		}

	if (ym<yw)
	{

	if (miny>ym) miny=ym;
	if (maxy<yw) maxy=yw;

	delta_x=(xyw-xym) << prec; delta_x/=yw-ym;

	x_dokl=xym << prec;

	// jezeli ym lub yw wychodza spoza zakresu nalezy je obciac
	// i zmodyfikowac odpowiednio xm, xw

	if ((xyw<0) && (xym<0))
		{
		// for (y=ym;y<=yw;y++) T[y]=0;

		asm {
			push ax
			push cx
			push es
			push di

			mov ax,T_seg
			mov es,ax
			mov di,T_off

			add di,ym
			add di,ym // 2 bajty na int !!!

			mov cx,yw
			sub cx,ym
			inc cx

			xor ax,ax

			rep stosw

			pop di
			pop es
			pop cx
			pop ax

			}

		}
		else
	if ((xyw>319) && (xym>319))
		{
		// for (y=ym;y<=yw;y++) T[y+200]=319;
		asm {
			push ax
			push cx
			push es
			push di

			mov ax,T_seg
			mov es,ax
			mov di,T_off

			add di,ym
			add di,ym // 2 bajty na int !!!
			add di,400

			mov cx,yw
			sub cx,ym
			inc cx

			mov ax,319

			rep stosw

			pop di
			pop es
			pop cx
			pop ax

			}

		}
		else
	  {
		asm {
		push ax
		push bx
		push cx
		push es
		push di

		mov di,T_seg
		mov es,di

		mov bx,ym

		mov di,T_off
		add di,bx
		add di,bx

		mov cx,prec

		}
		petla:
		asm {
		mov ax,x_dokl
		sar ax,cl

		cmp ax,0
		jge wieksze_od_0
		mov ax,0
		}
		wieksze_od_0:
		asm {
		cmp ax,319
		jle mniejsze_od_319
		mov ax,319
		}
		mniejsze_od_319:
		asm {
		cmp es:[di],ax
		jle nie_wieksze
		mov es:[di],ax
		}
		nie_wieksze:
		asm {
		cmp es:[di+400],ax
		jge nie_mniejsze
		mov es:[di+400],ax
		}
		nie_mniejsze:
		asm {

		inc bx
		cmp bx,yw
		jg koniec

		add di,2
		mov ax,delta_x
		add x_dokl,ax

		jmp petla
		}
		koniec:
		asm {
		pop di
		pop es
		pop cx
		pop bx
		pop ax
		}
	  }


	  }}}}
}



void czworokat(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4)
{
 przygotuj_fill();

 linia(x1,y1,x2,y2);
 linia(x2,y2,x3,y3);
 linia(x3,y3,x4,y4);
 linia(x4,y4,x1,y1);

 fill();
}


void czworokat_kolizja(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4)
{
 przygotuj_fill();

 linia(x1,y1,x2,y2);
 linia(x2,y2,x3,y3);
 linia(x3,y3,x4,y4);
 linia(x4,y4,x1,y1);

 if ((T[kolizja_y]<=kolizja_x) && (T[kolizja_y+200]>=kolizja_x))
	kolizja=1;

 fill();
}
