;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Wlasna procedura obslugi klawiatury
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


PUBLIC _INSTALL_TESTKEY, _DEINSTALL_TESTKEY

MODEL COMPACT

GLOBAL _MYKEY:BYTE


.DATA

OldInterr DD ?
_MYKEY DB ?

.CODE

.386

;;;;;;; Procedura przerwania - testowanie klawiatury

_TESTKEY proc FAR

	push ax
	push ds

	mov ax,SEG DGROUP
	mov ds,ax
	in al,60h

	mov _MYKEY,al

	mov al,20h
	out 20h,al

	pop ds
	pop ax
	iret

endp _TESTKEY

;;;;;;; Instalacja procedury przerwania

_INSTALL_TESTKEY proc
	push dx
	push ds
	push ax

	mov ax,3509h

	int 21h
	mov [WORD PTR OldInterr],bx
	mov [WORD PTR OldInterr + 2],es

	mov ax,SEG _TESTKEY
	mov ds,ax

	mov dx,OFFSET _TESTKEY
	mov ax,2509h

	int 21h
	pop ax
	pop ds
	pop dx
	ret
endp _INSTALL_TESTKEY


_DEINSTALL_TESTKEY proc
	push dx
	push ds
	push ax

	mov ax,2509h
	lds dx,OldInterr

	int 21h

	pop ax
	pop ds
	pop dx
	ret
endp _DEINSTALL_TESTKEY



END
