#ifndef GRAFIKA

/*
	Modul graficzny
*/

#define GRAFIKA


#include <process.h>
#include <iostream.h>
#include <stdarg.h>
#include <conio.h>
#include <stdio.h>

#define calkowita int
#define jezeli if
#define wtedy
#define prywatne private
#define publiczne public
#define klasa class
#define znak char
#define pusty_typ void
#define skasuj delete
#define zarezerwuj new
#define konstruktor
#define destruktor
#define petla(zmienna,granica) for (zmienna=0;zmienna<granica;zmienna++)
#define nieujemna unsigned
#define zwroc return
#define max(a,b) (a>=b ? a : b)
#define min(a,b) (a<=b ? a : b)
#define przyjaciel friend


// definicje typow

typedef unsigned char far bajt;
typedef char* tekst;



klasa obrazek
{
przyjaciel klasa gracz;
prywatne:
	bajt *pamiec;

	inline obrazek *wskaznik(pusty_typ) { zwroc this; }

publiczne:
	konstruktor obrazek(pusty_typ): pamiec(NULL) {}
	konstruktor obrazek(tekst nazwa_pliku): pamiec(NULL)
			{ wczytaj_plik(nazwa_pliku); }

	destruktor ~obrazek(pusty_typ)
			{ jezeli (pamiec) wtedy skasuj pamiec; }

	pusty_typ wczytaj_plik(tekst nazwa_pliku);
	pusty_typ zarezerwuj_pamiec(nieujemna wielkosc);

	nieujemna szerokosc(pusty_typ);
	nieujemna wysokosc(pusty_typ);
	nieujemna wielkosc_pamieci(pusty_typ);
	inline pusty_typ ustaw_wysokosc(nieujemna wysokosc);
	inline pusty_typ ustaw_szerokosc(nieujemna szerokosc);

	pusty_typ narysuj_gracza(calkowita x,calkowita y);
	pusty_typ narysuj_ducha(calkowita x,calkowita y);
	pusty_typ narysuj_tlo(calkowita x,calkowita y);
	pusty_typ wez_tlo(calkowita x,calkowita y);
	pusty_typ odbij(pusty_typ);
};


typedef obrazek* wskaznik_na_obrazek;
typedef obrazek& referencja_na_obrazek;


klasa gracz
{
prywatne:
	calkowita ilosc_wzorow,aktualny_wzor;
	wskaznik_na_obrazek *moje_wzory;
	obrazek tlo;
	calkowita px,py;	// pozycja tla na ekranie

	pusty_typ zarezerwuj_tlo(pusty_typ);

publiczne:
	konstruktor gracz(calkowita ilosc...);
	konstruktor gracz(wskaznik_na_obrazek wzor) { gracz::gracz(1,wzor); }

	destruktor ~gracz(pusty_typ);

	pusty_typ narysuj_gracza(nieujemna wzor,calkowita x,calkowita y);
	pusty_typ narysuj_ducha(nieujemna wzor,calkowita x,calkowita y);
	pusty_typ odtworz_tlo(void);
};



// bufor graficzny
extern bajt *bufor;


klasa ekran
{
publiczne:
	ekran(pusty_typ);
	~ekran(pusty_typ);
	pusty_typ bufor_na_ekran(pusty_typ);
	pusty_typ bufor_na_ekran2(pusty_typ);
};


klasa zbior_obrazkow
{
prywatne:
	nieujemna ilosc;
	obrazek *moje_obrazki;
publiczne:
	konstruktor zbior_obrazkow(tekst nazwa_pliku);
	destruktor ~zbior_obrazkow(pusty_typ);
	inline obrazek& operator[](calkowita indeks)
		{ return moje_obrazki[indeks]; }
	inline ilosc_obrazkow(pusty_typ) { zwroc ilosc; }
};


#endif
