#ifndef JOYSTICK

#define JOYSTICK

class joystick
{
public:
unsigned posx,posy;
unsigned trigger1,trigger2,trigger3,trigger4;
unsigned toread;


void readx(void);
void ready(void);

void readnext(void)
	{
	if (toread==0)
		{
		readx(); toread=1;
		}
		else
	if (toread==1) toread=2;
		else
	if (toread==2)
		{
		ready(); toread=3;
		}
	if (toread==3) toread=0;
	}


joystick(void): toread(0), posx(600), posy(600), trigger1(0), trigger2(0),
	trigger3(0), trigger4(0)
	{
	readx();
	ready();
	}

};



void joystick::ready(void)
{
unsigned wynik;
unsigned char triggers;

	asm {
	push ax
	push bx
	push dx

	mov dx,0x201
	out dx,al	// Kippstufe
	mov al,0

	out 0x43,al	// Zaehler-Latch-Befehl an Steuerreigster des PIT
	in al,0x40
	mov ah,al
	in al,0x40
	xchg ah,al

	mov bx,ax
	}
	check_x:
	asm {
	in al,dx
	test al,2
	jnz check_x
	xor al,255
	mov triggers,al

	mov al,0
	out 0x43,al
	in al,0x40
	mov ah,al
	in al,0x40
	xchg ah,al
	sub ax,bx

	xor ax,0xffff
	mov wynik,ax

	pop dx
	pop bx
	pop ax
	}

posy=wynik;
trigger1=triggers & 16;
trigger2=triggers & 32;
trigger3=triggers & 64;
trigger4=triggers & 128;
}



void joystick::readx(void)
{
unsigned wynik;
unsigned char triggers;

	asm {
	push ax
	push bx
	push dx

	mov dx,0x201
	out dx,al	// Kippstufe
	mov al,0

	out 0x43,al	// Zaehler-Latch-Befehl an Steuerreigster des PIT
	in al,0x40
	mov ah,al
	in al,0x40
	xchg ah,al

	mov bx,ax
	}
	check_x:
	asm {
	in al,dx
	test al,1
	jnz check_x
	xor al,255
	mov triggers,al

	mov al,0
	out 0x43,al
	in al,0x40
	mov ah,al
	in al,0x40
	xchg ah,al
	sub ax,bx

	xor ax,0xffff
	mov wynik,ax

	pop dx
	pop bx
	pop ax
	}

posx=wynik;
trigger1=triggers & 16;
trigger2=triggers & 32;
trigger3=triggers & 64;
trigger4=triggers & 128;
}




#endif