




// modul do przeliczania polozenia punktow trojwymiarowych
// na ekranie obserwatora


// plik naglowkowy

//			by Pawel Biernacki

extern int
	ex,ey,ez, // oko
	px,py,pz, // P - srodek ekranu
	pxx,pxy,pxz, // PX - wektor od srodka do gornej krawedzi ekranu
	pyx,pyy,pyz, // PY - wektor od srodka do prawej krawedzi ekranu
	pex,pey,pez, // PE - wektor od srodka ekranu do oka

	qx,qy,qz, // Q
	qxx,qxy,qxz, // QX
	qyx,qyy,qyz, // QY
	// wspolrzedne wektorow, ktorych iloczyny skalarne z wektorem SE
	// daja odpowiednie wyznaczniki

	sex,sey,sez,
	// wspolrzedne wektora SE ( S jest odwzorowywanym punktem )

	xe,ye,
	// wspolrzedne punktu na ekranie obserwatora

	widoczny,
	// znacznik - "1" oznacza, ze punkt jest widoczny

	WK_mlodszy,WK_starszy;
	// wyznacznik WK ( staly w jednym polozeniu obserwatora )

extern void oblicz_q(void),oblicz_pozycje(void);

// oblicz_q - obliczenie wektorow Q na podstawie danych ekranu obserwatora
// oblicz_pozycje - obliczenie xe i ye na podstawie wektorow Q i SE


// parametry sterujace precyzja reprezentacji sa zdefiniowane jako stale
// preprocesora w module zrodlowym KAMERA.CPP
#define PREC 6
